<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/TR/REC-html40"> 
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>fwAccessControl_LogWindow.pnl 
panel</title>
<link rel="StyleSheet" HREF="style.css" TYPE="text/css" MEDIA="screen,print">
</head>
<body>
<table width="95%" border="1"><tbody>
<tr vAlign="top">
<td width="22%" bgColor="#00cc00"><strong>Panel Name</strong></td>
<td width="78%" colSpan="2">fwAccessControl/fwAccessControl_LogWindow.pnl</td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Introduction<br></strong></td>
<td colSpan="2">
<p>Log Window panel</p>
<p>
    <p>
    This panel is used to display a multi-line message in a window that contains a scrollbar.<br>
    Figure 1 presents an example - the list of dependencies displayed by
    the <a href="fwAccessControl_Export.htm">Export Panel</a> .
    <div xmlns:html="http://www.w3.org/1999/xhtml" class="figure"><table align="center">
<tr><td><img src="fwAccessControl_LogWindow.png"></td></tr>
<tr><td><span class="caption">Figure 1: Log window displaying some information</span></td></tr>
</table></div>
    </p>
    <p> Depending on the context, the user may want to press the <span class="button">OK</span> or <span class="button">Cancel</span>
    button, expressing his decision. The information is returned to the parent panel. <br>
    In the example above, pressing the <span class="button">OK</span> button will trigger an operation of dependency
    resolving, and append required objects to user's selection.
    </p>
</p>
<br>
</td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Instructions</strong></td>
<td colSpan="2"><dl>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To accept/confirm:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml"> Press the <span class="button">OK</span> button</dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To cancel/reject:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml"> Press the <span class="button">Cancel</span> button</dd>
</dl></td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Restrictions</strong></td>
<td colSpan="2"><ul></ul></td>
</tr>
</tbody></table>
<br><table width="95%" border="1"><tbody>
<tr bgColor="#00cc00"><td colSpan="3"><strong>Dollar Parameters</strong></td></tr>
<tr bgColor="#00cc00">
<td width="23%"><strong>Name</strong></td>
<td width="62%"><strong>Description</strong></td>
<td width="15%">&nbsp;</td>
</tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td>$log</td>
<td> The lines of text displayed in the log window; <br>
	<p>
    Even though the type of the dollar parameter is <em>string</em>, you may pass multiple lines
    of text: <em>dyn_string</em> variables passed as string will be restored and each element
    displayed as separate line; the newline (\n) characters will also be interpretted as end of line
    marks. </p>
    <p>
    The following example code demonstrates how multiple-line text may be passed to the panel:
<pre>
dyn_string df;
dyn_string ds;
dyn_string logMessage = makeDynString("A requires B",
				"B requires C \n and requires D");

ChildPanelOnCentralReturn("fwAccessControl/fwAccessControl_LogWindow.pnl",
    "Unresolved dependencies",
    makeDynString("$log:"+logMessage,
	"$text:There were unresolved dependencies",
	"$text2:Press OK to accept, or Cancel to abort"),
    df,ds);						    
if (df[1]==1.0) { 
    // OK was pressed
} else {
    // Cancel was pressed
}
</pre>
</p>
</td>
<td>required</td>
</tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td>$text</td>
<td> The text displayed on the top of the panel </td>
<td>required</td>
</tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td>$text2</td>
<td> The text displayed at the bottom of the panel </td>
<td>optional</td>
</tr>
</tbody></table>
<br>
<table width="95%" border="1"><tbody>
<tr bgColor="#00cc00"><td colSpan="3"><strong>Return Values from panel</strong></td></tr>
<tr><td colspan="3"> The panel should be opened using functions from the
        <code>ChildPanel...Returns(... , df,ds)</code> family. <br>
        When the panel is closed the following values may be returned in the 
        <code>df</code> and <code>ds</code> parameters:
    </td></tr>
<tr bgColor="#00cc00">
<td width="60"><strong>Variable</strong></td>
<td width="10%"><strong>Value(s)</strong></td>
<td><strong>Description</strong></td>
</tr>
<tr bgColor="#ccffcc"><td colspan="3" align="center">
<code>dyn_float</code>  parameter (<code>df[]</code>)</td></tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>df[1]</code></td>
<td><code>1</code></td>
<td> <span class="button">OK</span> button was pressed</td>
</tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>df[1]</code></td>
<td><code>0</code></td>
<td> <span class="button">Close</span> button was pressed</td>
</tr>
<tr bgColor="#ccffcc"><td colspan="3" align="center">
<code>dyn_string</code> parameter (<code>ds[]</code>)</td></tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>ds[]</code></td>
<td><code></code></td>
<td> not used: empty variable is always returned.</td>
</tr>
</tbody></table>
<br><a href="../../fwAccessControl.htm">
Back to the documentation of the
	    fwAccessControl
component.
	    </a> <br xmlns:html="http://www.w3.org/1999/xhtml"><hr xmlns:html="http://www.w3.org/1999/xhtml">
<font xmlns:html="http://www.w3.org/1999/xhtml" size="-1"> Piotr Golonka, <a href="http://cern.ch/itcobe">CERN IT/CO-BE</a></font>
</body></html>
